/*
 *	file:		ParanoiaHelp.java
 * project:	Paranoia
 * content:	help for Paranoia
 * updated:	Sep. 08. 2002
 *
 */

package org.mulliner.paranoia;

  
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;


public class ParanoiaHelp extends Form implements CommandListener
{
	private static final Command[] COMMANDS = {
		new Command("Done", Command.OK, 1)
	};
	
	private Display display;
	private Backable winBack;
	
	
	public ParanoiaHelp()
	{
		super("Help");
		
		append(	"Paranoia is a RFC1938 conform " +
					"One-Time Password generator with support " +
					"for MD5, MD4 and SHA-1. PassPhrase length is limited " +
					"to 63 characters. The generated password is shown in " +
					"6 word and hex format.\n\n" +
					"... Collin\n" +
					"PS: and yes I have too much free time ;-]");
				
		for (int i = 0; i < COMMANDS.length; i++) {
			addCommand(COMMANDS[i]);
		}
	}
	
	public void activate(Display d, Backable b)
	{
		display = d;
		winBack = b;
		
		display.setCurrent(this);
		setCommandListener(this);
	}
	
	public void commandAction(Command cmd, Displayable s)
	{
		if (cmd == COMMANDS[0]) {
			winBack.show();
		}
	}
}
